#pragma once

namespace asyncpp
{

    /* storage_type */

    template<typename X_type>
    struct storage_type<move, X_type, void>
        { using type = X_type; };

    template<typename X_type>
    struct storage_type<copy, X_type, void>
        { using type = X_type; };

    template<typename X_type>
    struct storage_type<ref, X_type, void>
        { using type = X_type&; };

    /* forward_type */

    template<typename X_type>
    struct forward_type<move, X_type, void>
        { using type = std::decay_t<X_type> &&; };

    template<typename X_type>
    struct forward_type<copy, X_type, void>
        { using type = std::decay_t<X_type> const &; };

    template<typename X_type>
    struct forward_type<ref, X_type, void>
        { using type = std::remove_reference_t<X_type> &; };

}
