#pragma once

#include <chrono>

namespace asyncpp
{

    using clock = std::chrono::steady_clock;

    using time_point = clock::time_point;

    template<typename T_base, typename T_ratio>
    using duration = std::chrono::duration<T_base ,T_ratio>;

    /**
     * @brief Get the current time point.
     */
    inline time_point now();

    /**
     * @brief Returns the lowest of the two passed deadlines (if not null)
     *        or nullptr if no deadline was passed.
     */
    inline const time_point * merge_deadlines(
        const time_point * p_deadline_0,
        const time_point * p_deadline_1);

}
