#pragma once

#include <variant>

namespace asyncpp
{

    enum class result_status
    {
        unknown = 0,
        not_ready,
        ready,
        done,
    };

    namespace __impl
    {

        template<bool for_stream, typename T_value>
        struct result;

    }

    template<typename T_value>
    using future_result = __impl::result<false, T_value>;

    template<typename T_value>
    using stream_result = __impl::result<true, T_value>;

}
