#pragma once

#include <asyncpp/core/future/future.h>

#include "directory.h"

namespace asyncpp {
namespace fs {
namespace __directory {

    template<
        chaining_mode X_mode,
        typename X_self>
    inline auto create_all_impl(X_self&& p_self)
    {
        return lazy([self = std::forward<X_self>(p_self)] {
            if (!self.handle.exists())
                self.handle.create(true);

            return self; // TODO: use std::forward
        });
    }

} } }

namespace asyncpp {
namespace fs {

    /* directory::create */

    template<chaining_mode X_mode>
    auto directory
        ::create_all() &
    {
        return __directory::create_all_impl<X_mode>(*this);
    }

    template<chaining_mode X_mode>
    auto directory
        ::create_all() &&
    {
        static_assert(
            X_mode != ref,
            "Can not store rvalue reference as lvalue reference!");

        return __directory::create_all_impl<X_mode>(std::move(*this));
    }

} }
