#pragma once

#include <memory>

#include <asyncpp/core/misc.h>
#include <asyncpp/core/task.h>

#include "timer_base.pre.h"

namespace asyncpp {
namespace timing {
namespace __impl {

    struct resource
    {
    public:
        timer_base&         owner;
        const time_point    deadline;
        const asyncpp::task task;

        /**
         * @brief Constructor.
         */
        inline resource(
            timer_base&             p_owner,
            const time_point&       p_deadline,
            const asyncpp::task&    p_task);
    };

    using resource_ptr_w = std::weak_ptr<resource>;
    using resource_ptr_s = std::shared_ptr<resource>;

} } }
