#pragma once

#include "timer.h"

#include "timer_impl.inl"

namespace asyncpp {
namespace timing {

    /* timer */

    template<typename T_inner>
    template<typename... X_args>
    timer<T_inner>::timer(X_args&&... p_args)
        : base_type(std::forward<X_args>(p_args)...)
        { }

    template<typename T_inner>
    void timer<T_inner>::idle(const time_point * p_deadline)
    {
        auto now = asyncpp::now();

        {
        auto r = this->_resources.lock();
        auto it = r->begin();
        while (it != r->end() && now >= (**it).deadline)
        {
            (**it).task.notify();
            ++it;
        }
        }

        base_type::idle_impl(p_deadline);
    }

    template<typename T_inner>
    auto timer<T_inner>::init_thread()
        { return base_type::init_thread_impl(); }

} }
