#include <gtest/gtest.h>
#include <gmock/gmock.h>

#include <asyncpp.h>

#include "../../helper/test_delay.h"

using namespace ::testing;
using namespace ::asyncpp;

struct task_handle
    : public task::handle
{
    MOCK_METHOD0(notify, void ());
};

TEST(task_tests, lock_and_notify)
{
    auto handle = std::make_shared<StrictMock<task_handle>>();

    EXPECT_CALL(*handle, notify);

    auto t = task::current();
    t.notify(); // nop

    auto lock = task::lock(handle);

    t = task::current();
    t.notify(); // actual notify
}
