#pragma once

#include <gtest/gtest.h>
#include <gmock/gmock.h>

#define __asyncpp_has_impl_timer_now

#include <asyncpp/core/misc.h>

struct now_mock;

static now_mock * __now_mock_instance;

struct now_mock
{
public:
    inline now_mock()
        { __now_mock_instance = this; }

    inline ~now_mock()
    {
        if (__now_mock_instance == this)
            __now_mock_instance = nullptr;
    }

public:
    MOCK_METHOD0(now, asyncpp::time_point());
};

namespace asyncpp
{

    time_point now()
    {
        return __now_mock_instance
            ? __now_mock_instance->now()
            : std::chrono::steady_clock::now();
    }

}
